## kelbt 0.12

=== cxxprep/Makefile ===
#
#  Copyright 2004-2006 Adrian Thurston <thurston@cs.queensu.ca>
#

#  This file is part of C++ Pre-Parser.
# 
#  C++ Pre-Parser is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
# 
#  C++ Pre-Parser is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
# 
#  You should have received a copy of the GNU General Public License
#  along with C++ Pre-Parser; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 

TARG = scanner

INCS = -I ../aapl
DEFS =
CFLAGS = -g -Wall
LDFLAGS = -g

CC_SRCS = main.cpp scanner.cpp parser.cpp keys.cpp names.cpp
CC_HEADERS = parser.h

#*************************************

# Programs
CXX = c++
AR = ar
KELBT = ../kelbt/kelbt
RAGEL = ragel
RLCODEGEN = rlgen-cd

# Get objects, dependencies from sources.
OBJS = $(CC_SRCS:%.cpp=%.o)
DEPS = $(CC_SRCS:%.cpp=.%.d)

# Rules.
all: cxxprep undo

cxxprep: $(KELBT) $(CC_HEADERS) $(CC_SRCS) $(OBJS)
	$(CXX) $(LDFLAGS) -o $@ $(OBJS)

undo: undo.lex
	flex -oundo.c undo.lex
	gcc -o undo undo.c

keys.cpp: keys.gperf
	gperf -L C++ -t $< > $@

parser.h: parser.kh $(KELBT)
	$(KELBT) -o $@ $<
parser.cpp: parser.kl parser.kh $(KELBT)
	$(KELBT) -o $@ $<


%.cpp: %.rl
	$(RAGEL) $< | $(RLCODEGEN) -G2 -o $@

%.o: %.cpp
	@$(CXX) -M $(CFLAGS) $(DEFS) $(INCS) $< > .$*.d
	$(CXX) -c $(CFLAGS) $(DEFS) $(INCS) -o $@ $<

distclean: clean
	rm -f Makefile config.h config.cache config.status config.log

clean:
	rm -Rf .*.d *.o cxxprep scanner.cpp \
		parser.{h,cpp} keys.cpp undo.c undo

-include $(DEPS)

PREFIX = /usr/local

install:
	install -d $(PREFIX)/bin
	install -m 755 cxxprep $(PREFIX)/bin/

=== kelbt/Makefile ===
#
#   Copyright 2001-2003, 2005 Adrian Thurston <thurston@cs.queensu.ca>
#

#   This file is part of Kelbt
#
#   Kelbt is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   Kelbt is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with Kelbt; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 

INCS = -I../aapl
DEFS =

CFLAGS = -g -Wall
LDFLAGS =

CC_SRCS = \
	pcheck.cpp main.cpp parsedata.cpp closure.cpp fsmbase.cpp fsmattach.cpp \
	fsmgraph.cpp codegen.cpp gvdotgen.cpp klscan.cpp klparse.cpp


LIBS = 
prefix = /usr/local

#*************************************

# Programs
CXX = g++

# Get objects and dependencies from sources.
OBJS = $(CC_SRCS:%.cpp=%.o)
DEPS = $(CC_SRCS:%.cpp=.%.d)

# Get the version info.
include ../version.mk

# Rules.
all: kelbt

kelbt: $(GEN_SRC) $(OBJS)
	$(CXX) $(LDFLAGS) -o $@ $(OBJS) $(LIBS)


%.o: %.cpp
	@$(CXX) -M $(DEFS) $(INCS) $< > .$*.d
	$(CXX) -c $(CFLAGS) $(DEFS) $(INCS) -o $@ $<

install: all
	install -d $(prefix)/bin
	install -s kelbt $(prefix)/bin/kelbt

distclean: clean
	rm -f Makefile

clean:
	rm -Rf kelbt tags .*.d *.o klscan.cpp klparse.h klparse.cpp version.h

-include $(DEPS)

=== test/Makefile ===
#
#   Copyright 2006 Adrian Thurston <thurston@cs.queensu.ca>
#

#   This file is part of Kelbt.
#
#   Kelbt is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   Kelbt is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with Kelbt; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 

test:
	@./runtests

clean:
	rm -f *.c *.cpp *.m *.d *.bin *.exp *.out

distclean: clean

## kelbt 0.15

=== cxxprep/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-#  Copyright 2004-2006 Adrian Thurston <thurston@cs.queensu.ca>
+#  Copyright 2004-2006 Adrian Thurston <thurston@complang.org>
 #
 
 #  This file is part of C++ Pre-Parser.
@@ -68,7 +68,6 @@
 	$(CXX) -c $(CFLAGS) $(DEFS) $(INCS) -o $@ $<
 
 distclean: clean
-	rm -f Makefile config.h config.cache config.status config.log
 
 clean:
 	rm -Rf .*.d *.o cxxprep scanner.cpp \

=== kelbt/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-#   Copyright 2001-2003, 2005 Adrian Thurston <thurston@cs.queensu.ca>
+#   Copyright 2001-2003, 2005 Adrian Thurston <thurston@complang.org>
 #
 
 #   This file is part of Kelbt

=== test/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-#   Copyright 2006 Adrian Thurston <thurston@cs.queensu.ca>
+#   Copyright 2006 Adrian Thurston <thurston@complang.org>
 #
 
 #   This file is part of Kelbt.

## kelbt 0.16

=== debian/changelog ===
kelbt (0.16-3) unstable; urgency=medium

  * QA upload.
  * Convert to 3.0 (quilt) format (Closes: #1007316).
  * d/copyright: Fix GPL version and convert to machine-readable format.

 -- Bastian Germann <bage@debian.org>  Thu, 25 Aug 2022 19:23:01 +0200

kelbt (0.16-2) unstable; urgency=medium

  * Maintenance release
    * Bumped standards-version and debhelper
  * Updated link to documentation

 -- Robert Lemmen <robertle@semistable.com>  Wed, 14 Mar 2018 19:21:52 +0100

kelbt (0.16-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Changed type for Parser_indicies from char to int8_t to fix
    narrowing conversion issue with gcc-6 (closes: #837184)

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Sat, 07 Jan 2017 21:55:12 +0100

kelbt (0.16-1) unstable; urgency=medium

  * New upstream release
  * Fixed watch file (closes: #796791)
  * Fixes to debian/rules and debian/control towards lintian-cleanliness
  * Bumped standards-version

 -- Robert Lemmen <robertle@semistable.com>  Mon, 06 Jun 2016 20:55:22 +0100

kelbt (0.15-1) unstable; urgency=low

  * New upstream release

 -- Robert Lemmen <robertle@semistable.com>  Wed, 30 May 2012 19:49:11 +0100

kelbt (0.14-1) unstable; urgency=low

  * New upstream release

 -- Robert Lemmen <robertle@semistable.com>  Mon, 12 Oct 2009 10:05:34 +0100

kelbt (0.13-1) unstable; urgency=low

  * New upstream release
  * Fixed watch file

 -- Robert Lemmen <robertle@semistable.com>  Thu, 12 Mar 2009 19:35:16 +0000

kelbt (0.12-1) unstable; urgency=low

  * Initial release (Closes: #440823)
  * Added licensing info for aapl

 -- Robert Lemmen <robertle@semistable.com>  Tue,  4 Sep 2007 17:11:25 +0200

=== debian/control ===
Source: kelbt
Section: devel
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: debhelper (>= 10.0.0)
Standards-Version: 4.1.3

Package: kelbt
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: backtracking LR parser generator
 Kelbt generates backtracking LALR(1) parsers. Standard LALR(1) parser
 generators emit an error upon encountering a conflict in the parse tables.
 Kelbt forges onward, generating parsers which handle conflicts by backtracking
 at runtime. Kelbt is able to generate a parser for any context-free grammar and
 therefore implements a generalized parsing method.
 .
 Kelbt is different from other backtracking LR systems in two ways. First, it
 elevates backtracking to the level of semantic actions by introducing a class
 of actions called undo actions. Undo actions are invoked as the backtracker
 undoes parsing and allow the user to revert any side effects of forward
 semantic actions. This makes it possible to backtrack over language constructs
 which must modify global state in preparation for handling context
 dependencies.
 .
 Second, Kelbt enables a user-controlled parsing strategy which approximates
 that of generalized recursive-descent parsing with ordered choice. This makes
 it easy for the user to resolve language ambiguities by ordering the grammar
 productions of a non-terminal according to precedence. It is approximate in the
 sense that for most grammars the equivalent of an ordered choice parsing
 strategy is achieved. In cases where productions are parsed out of the order
 given, there is a simple grammar transformation which remedies the problem.
 .
 As a proof of concept, Kelbt has been used to write a partial C++ parser
 (included) which is composed of strictly a scanner, a name lookup stage and a
 grammar with standard semantic actions and semantic undo actions.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

CXXFLAGS = -Wall -g $(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS = $(shell dpkg-buildflags --get LDFLAGS)

config.status: configure
	dh_testdir
	./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info CXXFLAGS="$(CXXFLAGS)" LDFLAGS="$(LDFLAGS)"


build: build-stamp

build-stamp:  config.status
	dh_testdir
	$(MAKE) CXXFLAGS="$(CXXFLAGS)" LDFLAGS="-Wl,-z,defs $(LDFLAGS)"
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp 
	[ ! -f Makefile ] || $(MAKE) distclean
	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	$(MAKE) prefix=$(CURDIR)/debian/kelbt/usr install

build-arch: build

build-indep: build

binary-indep: install

binary-arch: install
	dh_testdir
	dh_testroot
	dh_installchangelogs ChangeLog
	dh_installdocs
	dh_installexamples
	dh_installman debian/kelbt.1
	dh_link
	dh_strip
	dh_compress 
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

=== debian/watch ===
version=3
http://www.colm.net/files/kelbt/ kelbt-(.*)\.tar\.gz
